Index: source/simulation2/components/CCmpRangeManager.cpp
===================================================================
--- source/simulation2/components/CCmpRangeManager.cpp	(revision 13108)
+++ source/simulation2/components/CCmpRangeManager.cpp	(working copy)
@@ -22,6 +22,7 @@
 
 #include "simulation2/MessageTypes.h"
 #include "simulation2/components/ICmpPosition.h"
+#include "simulation2/components/ICmpObstructionManager.h"
 #include "simulation2/components/ICmpTerritoryManager.h"
 #include "simulation2/components/ICmpVision.h"
 #include "simulation2/helpers/Render.h"
@@ -1072,12 +1073,25 @@
 		if (!cmpTerritoryManager || !cmpTerritoryManager->NeedUpdate(&m_TerritoriesDirtyID))
 			return;
 
+		PROFILE3("UpdateTerritoriesLos");
+
 		const Grid<u8>& grid = cmpTerritoryManager->GetTerritoryGrid();
-		ENSURE(grid.m_W == m_TerrainVerticesPerSide-1 && grid.m_H == m_TerrainVerticesPerSide-1);
 
-		// For each tile, if it is owned by a valid player then update the LOS
-		// for every vertex around that tile, to mark them as explored
+		// Territory data is stored per territory-tile (typically a multiple of terrain-tiles).
+		// LOS data is stored per terrain-tile vertex.
 
+		// For each territory-tile, if it is owned by a valid player then update the LOS
+		// for every vertex inside/around that tile, to mark them as explored.
+
+		// Currently this code doesn't support territory-tiles smaller than terrain-tiles
+		// (it will get scale==0 and break), or a non-integer multiple, so check that first
+		cassert(ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE >= ICmpObstructionManager::NAVCELLS_PER_TILE);
+		cassert(ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE % ICmpObstructionManager::NAVCELLS_PER_TILE == 0);
+
+		int scale = ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE / ICmpObstructionManager::NAVCELLS_PER_TILE;
+
+		ENSURE(grid.m_W*scale == m_TerrainVerticesPerSide-1 && grid.m_H*scale == m_TerrainVerticesPerSide-1);
+
 		for (u16 j = 0; j < grid.m_H; ++j)
 		{
 			for (u16 i = 0; i < grid.m_W; ++i)
@@ -1085,10 +1099,9 @@
 				u8 p = grid.get(i, j) & ICmpTerritoryManager::TERRITORY_PLAYER_MASK;
 				if (p > 0 && p <= MAX_LOS_PLAYER_ID)
 				{
-					m_LosState[i + j*m_TerrainVerticesPerSide] |= (LOS_EXPLORED << (2*(p-1)));
-					m_LosState[i+1 + j*m_TerrainVerticesPerSide] |= (LOS_EXPLORED << (2*(p-1)));
-					m_LosState[i + (j+1)*m_TerrainVerticesPerSide] |= (LOS_EXPLORED << (2*(p-1)));
-					m_LosState[i+1 + (j+1)*m_TerrainVerticesPerSide] |= (LOS_EXPLORED << (2*(p-1)));
+					for (int dj = 0; dj <= scale; ++dj)
+						for (int di = 0; di <= scale; ++di)
+							m_LosState[(i*scale+di) + (j*scale+dj)*m_TerrainVerticesPerSide] |= (LOS_EXPLORED << (2*(p-1)));
 				}
 			}
 		}
Index: source/simulation2/components/CCmpRallyPointRenderer.cpp
===================================================================
--- source/simulation2/components/CCmpRallyPointRenderer.cpp	(revision 13108)
+++ source/simulation2/components/CCmpRallyPointRenderer.cpp	(working copy)
@@ -69,7 +69,7 @@
 {
 	// import some types for less verbosity
 	typedef ICmpPathfinder::Path Path;
-	typedef ICmpPathfinder::Goal Goal;
+	typedef PathGoal Goal;
 	typedef ICmpPathfinder::Waypoint Waypoint;
 	typedef ICmpRangeManager::CLosQuerier CLosQuerier;
 	typedef SOverlayTexturedLine::LineCapType LineCapType;
@@ -115,7 +115,6 @@
 	std::wstring m_LineTexturePath;
 	std::wstring m_LineTextureMaskPath;
 	std::string m_LinePassabilityClass; ///< Pathfinder passability class to use for computing the (long-range) marker line path.
-	std::string m_LineCostClass; ///< Pathfinder cost class to use for computing the (long-range) marker line path.
 
 	CTexturePtr m_Texture;
 	CTexturePtr m_TextureMask;
@@ -141,7 +140,6 @@
 				"<LineEndCap>square</LineEndCap>"
 				"<LineColour r='20' g='128' b='240'></LineColour>"
 				"<LineDashColour r='158' g='11' b='15'></LineDashColour>"
-				"<LineCostClass>default</LineCostClass>"
 				"<LinePassabilityClass>default</LinePassabilityClass>"
 			"</a:example>"
 			"<element name='MarkerTemplate' a:help='Template name for the rally point marker entity (typically a waypoint flag actor)'>"
@@ -196,9 +194,6 @@
 			"</element>"
 			"<element name='LinePassabilityClass' a:help='The pathfinder passability class to use for computing the rally point marker line path'>"
 				"<text />"
-			"</element>"
-			"<element name='LineCostClass' a:help='The pathfinder cost class to use for computing the rally point marker line path'>"
-				"<text />"
 			"</element>";
 	}
 
@@ -440,7 +435,6 @@
 	m_LineTextureMaskPath = paramNode.GetChild("LineTextureMask").ToString();
 	m_LineStartCapType = SOverlayTexturedLine::StrToLineCapType(paramNode.GetChild("LineStartCap").ToString());
 	m_LineEndCapType = SOverlayTexturedLine::StrToLineCapType(paramNode.GetChild("LineEndCap").ToString());
-	m_LineCostClass = paramNode.GetChild("LineCostClass").ToUTF8();
 	m_LinePassabilityClass = paramNode.GetChild("LinePassabilityClass").ToUTF8();
 
 	// ---------------------------------------------------------------------------------------------
@@ -612,7 +606,6 @@
 		pathStartY,
 		goal,
 		cmpPathfinder->GetPassabilityClass(m_LinePassabilityClass),
-		cmpPathfinder->GetCostClass(m_LineCostClass),
 		path
 	);
 
